#!/bin/bash -
# mpwebif.sh for IPFire Mail Gateway project
# add simple Logfile view function to IPFire web interface

WORKDIR=${PWD};
WEBDIR="/srv/web/ipfire/cgi-bin";
MENUFILE="/var/ipfire/menu.d/EX-mailgate.menu";
LANGDE="/var/ipfire/addon-lang/mailgate.de.pl";
LANGEN="/var/ipfire/addon-lang/mailgate.en.pl";

if [ ! -d /var/ipfire/mailgateway/maps ]; then
	rm -rdf /var/ipfire/mailgateway/maps;
	mkdir -p /var/ipfire/mailgateway/maps;
fi;
chmod 755 /var/ipfire/mailgateway/;
chmod 755 /var/ipfire/mailgateway/maps;
chown nobody:nobody /var/ipfire/mailgateway;
chown nobody:nobody /var/ipfire/mailgateway/maps;

echo -en "\033[32mInstall web interface now: \033[0m";
/bin/cp -f ${WORKDIR}/{mgconfig.cgi,mgquarantine.cgi} ${WEBDIR};
chmod +x ${WEBDIR}/{mgconfig.cgi,mgquarantine.cgi};
/bin/cp -f ${WORKDIR}/{mpsum.dat,mptrn.dat} ${WEBDIR}/logs.cgi/;
chmod +x ${WEBDIR}/logs.cgi/{mpsum.dat,mptrn.dat};

#set correct quarantine dir rights to access folder from webui
chmod 755 /var/virusmails/;

# add nobody to amavis group to download files in webui (reboot needed)
usermod -a -G amavis nobody;

# remove old postfix log show module
rm -f ${WEBDIR}/mplog.dat;

cat > ${LANGDE} << "EOF2"
%tr = ( 
%tr,
'mailgate' => 'Postfix Mail Gateway',
'mailgate days back' => 'Tage zurück',
'mailgate all files' => 'alle Dateien',
'mailgate configuration' => 'MailGate Konfiguration',
'mailgate configuration caption' => 'Konfiguration',
'mailgate files banned' => 'Mails mit unzulässigen Anhängen',
'mailgate files badh' => 'Mails mit fehlerhaften Kopfzeilen',
'mailgate files spam' => 'Spam Mails',
'mailgate quarantine' => 'MailGate Quarantäne',
'mailgate quarantine caption' => 'Mail Gateway - Quarantäne Dateiliste',
'mailgate quarantine release' => 'Mail zustellen',
'mailgate summary' => 'MailGate Verbindungen',
'mailgate summary caption' => 'Mail Gateway - Verbindungsübersicht',
'mailgate transport' => 'MailGate Transport',
'mailgate transport caption' => 'Mail Gateway - Mail transfer übersicht',
'mailgate sender' => 'Sender',
'mailgate recipient' => 'Empfänger',
'mailgate mydomain' => 'Primäre Relay-Domain',
'mailgate myhostname' => 'Externer Hostname',
'mailgate msip' => 'Mail-Server IP oder Name',
'mailgate msport' => 'Mail-Server TCP-Port',
'mailgate domainlist' => 'Weitere Relay-Domains',
'mailgate hostlist' => 'Weitere interne Relay-Hosts',
'mailgate extrelay caption' => 'Ausgehendes Relay Einstellungen',
'mailgate extrelay enable' => 'Externes Relay aktiv',
'mailgate extrelay host' => 'Externer Relay-Host',
'mailgate extrelay port' => 'Relay-Host TCP-Port',
'mailgate extrelay user' => 'Benutzer',
'mailgate extrelay pass' => 'Passwort',
'mailgate postfix daemon' => 'Postfix Dienst (Master)',
'mailgate amavis daemon' => 'Amavis Dienst',
'mailgate daemons' => 'MailGate Dienste',
'mailgate cert settings caption' => 'Zertifikat Einstellungen',
'mailgate cert contry code' => 'Land',
'mailgate cert contry' => 'Bundesstat oder Provinz',
'mailgate cert city' => 'Stadt',
'mailgate cert unit' => 'Name der Abteilung',
'mailgate cert orga' => 'Name der Organisation',
'mailgate cert mail' => 'Mail-Adresse',
'mailgate cert host' => 'Externer Hostname',
'mailgate cert create' => 'Erzeuge Zertifikat',
'mailgate cert rm' => 'Lösche Zertifikate',
'mailgate cert restart' => 'Speichern und Restart',
'mailgate cert dhlength' => 'DH-Parameter-Länge',
'mailgate cert dhgen' => 'Erzeuge DH-Paramater',
'mailgate cert type' => 'Zertifikat-Typ',
'mailgate cert hash' => 'Hash Algorithm',
'mailgate cert curve' => 'ECC Kurve',
'mailgate cert selfsinged' => 'Selbst signiert',
'mailgate cert letsencrypt' => "Let's Encrypt",
'mailgate cert rsa-cert' => 'RSA-Zeritfiakt',
'mailgate cert rsa-key' => 'RSA-Zeritfiakt Key',
'mailgate cert ecc-cert' => 'ECC-Zeritfiakt',
'mailgate cert ecc-key' => 'ECC-Zeritfiakt Key',
'mailgate cert dhfile' => 'DH-Parameter',
'mailgate cert missing' => 'Zeritfiakte unvollständig oder nicht vorhanden',
'mailgate cert notimpl' => 'Lets Encrypt noch nicht implementiert',
'mailgate cert ledomain' => "Let's Encrypt Account-Domain",
'mailgate invalid msip' => 'Ungülige Mail-Server Addresse',
'mailgate invalid mydomain' => 'Ungülige Mail-Domäne',
'mailgate invalid myhostname' => 'Ungüliger externer Hostname',
'mailgate invalid relay host' => 'Ungüliger Relay-Server IP oder Hostname',
'mailgate invalid relay account' => 'Ungülige Relay-Server Anmeldung',
'mailgate invalid hostlist' => 'Ungüliger host in Realy-Hosts Liste',
'mailgate invalid relaylist' => 'Ungülige Domain in Realy-Domain Liste',
'mailgate invalid ledomain' => "Ungülige Let's Encrypt Domain",
'mailgate ledomain not found' => "Let's Encrypt Domain nicht gefunden in Dehydrated Konfiguration",
'mailgate dehydrated missing' => 'Dehydrated Addon nicht gefunden. Bitte installieren...',
'mailgate dhfile not found' => 'DH-Parameterdatei nicht gefunden. Bitte erzeugen...',
);
#EOF
EOF2

cat > ${LANGEN} << "EOF2"
%tr = ( 
%tr,
'mailgate' => 'Mail Gateway',
'mailgate days back' => 'Days back',
'mailgate all files' => 'all files',
'mailgate configuration' => 'MailGate configuration',
'mailgate configuration caption' => 'Main configuration',
'mailgate files banned' => 'mails with banned attachments',
'mailgate files badh' => 'bad header mails',
'mailgate files spam' => 'spam mail',
'mailgate quarantine' => 'MailGate quarantine',
'mailgate quarantine caption' => 'Mail Gateway - quarantine files list',
'mailgate quarantine release' => 'release from quarantine',
'mailgate summary' => 'MailGate connections',
'mailgate summary caption' => 'Mail Gateway - connections view',
'mailgate transport' => 'MailGate transport',
'mailgate transport caption' => 'Mail Gateway - mail transport view',
'mailgate sender' => 'Sender',
'mailgate recipient' => 'Recipient',
'mailgate mydomain' => 'Relay domain',
'mailgate myhostname' => 'External hostname',
'mailgate msip' => 'Mail server IP or name',
'mailgate msport' => 'Mail server TCP port',
'mailgate domainlist' => 'Additional relay domains',
'mailgate hostlist' => 'Additional internal relay hosts',
'mailgate extrelay caption' => 'Outgoing relay settings',
'mailgate extrelay enable' => 'Enable external relay',
'mailgate extrelay host' => 'Outgoing relay host',
'mailgate extrelay port' => 'Relay host TCP port',
'mailgate extrelay user' => 'Outgoing relay user',
'mailgate extrelay pass' => 'Outgoing relay password',
'mailgate postfix daemon' => 'Postfix damaon (master)',
'mailgate amavis daemon' => 'Amavis daemon',
'mailgate daemons' => 'MailGate daemons',
'mailgate cert settings caption' => 'Certificate settings',
'mailgate cert contry code' => 'Country',
'mailgate cert contry' => 'State or province',
'mailgate cert city' => 'City',
'mailgate cert unit' => 'Your department',
'mailgate cert orga' => 'Organization name',
'mailgate cert mail' => 'Your e-mail address',
'mailgate cert host' => 'External hostname',
'mailgate cert create' => 'Create certificate',
'mailgate cert rm' => 'Remove certificate',
'mailgate cert save' => 'Speichern und Restart',
'mailgate cert dhlength' => 'DH parameters length',
'mailgate cert dhgen' => 'Create DH params',
'mailgate cert type' => 'Certificate type',
'mailgate cert hash' => 'Hash Algorithm',
'mailgate cert curve' => 'ECC certificate curve',
'mailgate cert selfsinged' => 'Self signed',
'mailgate cert letsencrypt' => "Let's Encrypt",
'mailgate cert rsa-cert' => 'RSA certificate',
'mailgate cert rsa-key' => 'RSA certificate key',
'mailgate cert ecc-cert' => 'ECC certificate',
'mailgate cert ecc-key' => 'ECC certificate key',
'mailgate cert dhfile' => 'DH parameter',
'mailgate cert missing' => 'Ceritfiactes missing',
'mailgate cert notimpl' => "Let's Encrypt is not implemented yet",
'mailgate cert ledomain' => "Let's Encrypt primary domain",
'mailgate invalid msip' => 'Invalid mail server IP',
'mailgate invalid mydomain' => 'Invalid mail domain',
'mailgate invalid myhostname' => 'Invalid external hostname',
'mailgate invalid relay host' => 'Invalid relay server IP or hostname',
'mailgate invalid relay account' => 'Invaild relay server account',
'mailgate invalid hostlist' => 'Invalid internal relay hosts in host list',
'mailgate invalid relaylist' => 'Invalid Domain in domain list',
'mailgate invalid ledomain' => "Invalid Let's Encrypt Domain",
'mailgate ledomain not found' => "Let's Encrypt domain not found in dehydrated configuration",
'mailgate dehydrated missing' => 'Dehydrated addon missing. Please install...',
'mailgate dhfile not found' => 'DH parameter file not found. Please create...',
);
#EOF
EOF2

cat > ${MENUFILE} << "EOF"
    $subservices->{'95.mgconfiguration'} = {
				'caption' => $Lang::tr{'mailgate configuration'},
				'uri' => '/cgi-bin/mgconfig.cgi',
				'title' => "$Lang::tr{'mailgate'}",
				'enabled' => 1
				};

    $subservices->{'96.mgquarantine'} = {
				'caption' => $Lang::tr{'mailgate quarantine'},
				'uri' => '/cgi-bin/mgquarantine.cgi',
				'title' => "$Lang::tr{'mailgate'}",
				'enabled' => 1
				};

    $sublogs->{'95.mailsum'} = {
				'caption' => $Lang::tr{'mailgate summary'},
				'uri' => '/cgi-bin/logs.cgi/mpsum.dat',
				'title' => "$Lang::tr{'mailgate'}",
				'enabled' => 1
				};

    $sublogs->{'96.mailtrn'} = {
				'caption' => $Lang::tr{'mailgate transport'},
				'uri' => '/cgi-bin/logs.cgi/mptrn.dat',
				'title' => "$Lang::tr{'mailgate'}",
				'enabled' => 1
				};
EOF

# set file rights
chown root:root ${LANGDE} ${LANGEN} ${MENUFILE};
chmod 0644 ${LANGDE} ${LANGEN} ${MENUFILE};

# update ipfire's language cache
/usr/local/bin/update-lang-cache;
unset WEBDIR WORKDIR;
echo -e "\033[92mDone...\033[0m";
echo " ";
#End of mpwebif.sh
